/* global mermaid */
/**
 * @file
 * Support mermaid rendering.
 */
(function (Drupal, mermaid, once) {
  Drupal.behaviors.diagramDisplay = {
    attach(context) {
      // Display mermaid containers after they're rendered.
      const mermaids = context.querySelectorAll('.mermaid');
      once('diagram-processed', mermaids).forEach(function (element) {
        // Initialize mermaid only if mermaids exist.
        if (mermaids.length > 0) {
          mermaid.initialize({
            startOnLoad: true,
            callback(id) {
              for (let index = 0; index < mermaids.length; index++) {
                mermaids[index].style.opacity = '100%';
              }
            },
          });
        }
      });
    },
  };
})(Drupal, mermaid, once);
